//package fi.hut.tcm.jacob.tcpip.demo;
import fi.hut.tcm.jacob.tcpip.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class Sender implements MouseMotionListener {
  private TextArea outArea;
  private int x_pos, y_pos;
  private JacobDatagramSocket socket;
  private InetAddress saddr;
  int sport;
  private byte buffer[];

  public Sender(TextArea reportArea, JacobDatagramSocket sockfd,
		InetAddress ser_addr, int ser_port) {
    outArea = reportArea;
    socket = sockfd;
    saddr = ser_addr;
    sport = ser_port;
    buffer = new byte[20];
  }

  public void mouseDragged(MouseEvent e) {
    // Right now, ignore dragging
  }

  public void mouseMoved(MouseEvent e)  {
    String astr;
    
    x_pos = e.getX();
    y_pos = e.getY();
    astr = "\nX=" + x_pos + ", Y=" + y_pos;
    outArea.append(astr);
    // Construct the packet to send:
    buffer[0] = (byte) (x_pos >> 8);
    buffer[1] = (byte) (x_pos & 0xff);
    buffer[2] = (byte) (y_pos >> 8);
    buffer[3] = (byte) (y_pos & 0xff);
    // Send the information to the server for processing
    DatagramPacket packet = new DatagramPacket(buffer, buffer.length, saddr, sport);
    try {
      socket.send(packet);
    } catch (java.io.IOException io) {
      System.err.println("Error sending UDP datagram: " + io);
    }
    Thread.currentThread().yield();
  }
}
