/**

    File:    EtherAdaptorAccessor.java


*/
package fi.hut.tcm.jacob.tcpip.arp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    EtherAdaptorAccessor
    
    Used to get by limitations in EthernetAdaptor.
*/
public class EtherAdaptorAccessor
  implements Accessor {

    public void setKey(Message message, Object key) {

      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOob();

      Object buf = message.getContents();
      
      UtilMsgr.i.setShort(buf, 6, ((Integer) key).intValue() );
      oob.setEthFrameType(((Integer) key).intValue());

      if (Arp.DebugLevel > 1) {  // #Debug#
	System.out.println("EtherAdaptorAccessor.setKey: Frame type set to: " +
			   ((Integer) key).intValue() );
      }
    }

    public Object getKey(Message message) {

      Object buf =  message.getContents();

      int frType = UtilMsgr.i.getShort(buf, 6);

      if (Arp.DebugLevel > 1) {  // #Debug#
	System.out.println("EtherAdaptorAccessor.getKey: Frame type is: " + frType);
      }

      return (new Integer(frType));
    }

    public void unsetKey(Message message) {
      // do nothing
    }

}; //ArpSelectorAccessor

