/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  EthernetHeaderSession (implementation)
    Package: arp
    File:    EthernetHeaderSession.java


*/
package fi.hut.tcm.jacob.tcpip.arp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    EthernetHeaderSession
    
    - Adds/Removes Ethernet header<br>
    - The Message Transporter calls EthernetHeaderSession.apply(Message) in
    order to tell the
         EthernetHeaderSession what message to use. The session then calls
    EthernetHeaderToNetMessenger
         apply(Message,State,Session) to inform the messenger what state
    and session to use. <br>
         - The EthernetToNetMessenger calls
    EthernetHeaderSession.applyToNet(self), which calls
         EthernetToNetMessenger.addEthernetHeader(). <br>
         - The EthernetFromNetMessenger calls
    EthernetHeaderSession.applyFromNet(self), which calls
         EthernetFromNetMessenger.removeEthernetHeader()
*/
public class EthernetHeaderSession
  extends Session {
    public long etherAddr;

    /**
        Constructor for EthernetHeaderSession.
    */
    public EthernetHeaderSession(State initialState, long etheraddr) {
    //+ EthernetHeaderSession::EthernetHeaderSession(State, long)
      super(initialState);
      etherAddr = etheraddr;
    //- EthernetHeaderSession::EthernetHeaderSession(State, long)
    }

}; //EthernetHeaderSession

