/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpChecksumState (implementation)
    Package: ip
    File:    IpChecksumState.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;

/**
    IpChecksumState
    
    Checks the validity of an IP packet
*/
public class IpChecksumState
  implements State {

  public static final IpChecksumState instance = new IpChecksumState();


    /**
        Calls the IPChecksumFromNetMessenger messenger's validChecksum().
        If the checksum is wrong, the packet is discarded
        
        
    */
    public void applyFromNet(Message message, Messenger messenger) {
    //+ IpChecksumState::applyFromNet(Message, Messenger)
      IpChecksumFromNetMessenger msgr = (IpChecksumFromNetMessenger) messenger;
      if (!msgr.validChecksum(message)) {
	System.err.println("IP checksum failed. Datagram discarded.");
	message.stopTransportation();
      }
      message.setMessenger(IpFragmentationFromNetMessenger.instance);
    //- IpChecksumState::applyFromNet(Message, Messenger)
    }

    /**
        Calls the IpChecksumToNetMessenger messenger's calculateChecksum().
    */
    public void applyToNet(Message message, Messenger messenger) {
    //+ IpChecksumState::applyToNet(Message, Messenger)
      IpChecksumToNetMessenger msgr = (IpChecksumToNetMessenger) messenger;
      msgr.calculateChecksum(message);
    //- IpChecksumState::applyToNet(Message, Messenger)
    }

}; //IpChecksumState
