/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  IpHeaderFromNetMessenger (implementation)
    Package: ip
    File:    IpHeaderFromNetMessenger.java


*/
package fi.hut.tcm.jacob.tcpip.ip;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    IpHeaderFromNetMessenger
    
    Provides the method removeIpHeader() for use by IpHeaderState.
*/
public class IpHeaderFromNetMessenger
  extends IpMessenger {
    public static IpHeaderFromNetMessenger instance = new IpHeaderFromNetMessenger();

    /**
        This method is probably going to replace removeIpHeader(),
        effectively ignoring the existence of IpHeaderState.
    */
    public void apply(Message message, State state, Session session) {
    //+ IpHeaderFromNetMessenger::apply(Message, State, Session)
      IpHeaderState st = (IpHeaderState) state;
      st.applyFromNet(message, this);
    //- IpHeaderFromNetMessenger::apply(Message, State, Session)
    }

    /**
        Remove an IP header frame from message
    */
    public void removeIpHeader(Message message) {
    //+ IpHeaderFromNetMessenger::removeIpHeader(Message)
      // DEBUG:
      // IpStubMessenger.instance.printHeader(message);
      BinaryBuffer buffer = message.getBuffer();
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOutOfBand();

      int hlen = 5 * 4; // XXX No options yet
      int destIpAddr = getDestIpAddr(message);
      int totlen = getTotalLength(message);
      oob.setDestIpAddr(destIpAddr);
      oob.setDataLen(totlen - hlen);
      buffer.removeHeader(hlen);
    //- IpHeaderFromNetMessenger::removeIpHeader(Message)
    }

}; //IpHeaderFromNetMessenger

