/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  UdpHeaderState (implementation)
    Package: udp
    File:    UdpHeaderState.java


*/
package fi.hut.tcm.jacob.tcpip.udp;
import fi.hut.tcm.jacob.conduits.*;
import fi.hut.tcm.jacob.tcpip.*;

/**
    UdpHeaderState
    
    
*/
public class UdpHeaderState
  implements State {
    public static UdpHeaderState instance = new UdpHeaderState();

    public void applyToNet(Message message, Session session, Messenger messenger) {
    //+ UdpHeaderState::applyToNet(Message, Session, Messenger)
      UdpHeaderToNetMessenger msgr = (UdpHeaderToNetMessenger) messenger;
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOutOfBand();

      msgr.addUdpHeader(message);

      msgr.setSrcPort(message, ((UdpHeaderSession) session).getPort());
      msgr.setDestPort(message, oob.getDestPort());
      msgr.setLength(message, message.getBuffer().getLength());

      message.setMessenger(UdpChecksumToNetMessenger.instance);
    //- UdpHeaderState::applyToNet(Message, Session, Messenger)
    }

    public void applyFromNet(Message message, Messenger messenger) {
    //+ UdpHeaderState::applyFromNet(Message, Messenger)
      UdpHeaderFromNetMessenger msgr = (UdpHeaderFromNetMessenger) messenger;
      TcpipOutOfBand oob = (TcpipOutOfBand) message.getOutOfBand();

      oob.setSrcPort(msgr.getSrcPort(message));
      oob.setDestPort(msgr.getDestPort(message));

      msgr.removeUdpHeader(message);
    //- UdpHeaderState::applyFromNet(Message, Messenger)
    }

}; //UdpHeaderState

