/**
    Copyright (C) 1997 Pekka Nikander & Juha Prssinen.
    All rights Reserved.

    XXX   %Z%%M% version %I% date:%G%

    Module:  UdpMessenger (implementation)
    Package: udp
    File:    UdpMessenger.java


*/
package fi.hut.tcm.jacob.tcpip.udp;
import fi.hut.tcm.jacob.conduits.*;

/**
    UdpMessenger
    
    
*/
public abstract class UdpMessenger
  implements Messenger {

    public final int getSrcPort(Message message) {
    //+ UdpMessenger::getSrcPort(Message)
      return message.getBuffer().getShort(0);
    //- UdpMessenger::getSrcPort(Message)
    }

    public final void setSrcPort(Message message, int port) {
    //+ UdpMessenger::setSrcPort(Message, int)
      message.getBuffer().setShort(0, port);
    //- UdpMessenger::setSrcPort(Message, int)
    }

    public final int getDestPort(Message message) {
    //+ UdpMessenger::getDestPort(Message)
      return message.getBuffer().getShort(2);
    //- UdpMessenger::getDestPort(Message)
    }

    public final void setDestPort(Message message, int port) {
    //+ UdpMessenger::setDestPort(Message, int)
      message.getBuffer().setShort(2, port);
    //- UdpMessenger::setDestPort(Message, int)
    }

    public final int getLength(Message message) {
    //+ UdpMessenger::getLength(Message)
      return message.getBuffer().getShort(4);
    //- UdpMessenger::getLength(Message)
    }

    public final void setLength(Message message, int len) {
    //+ UdpMessenger::setLength(Message, int)
      message.getBuffer().setShort(4, len);
    //- UdpMessenger::setLength(Message, int)
    }

    public final int getChecksum(Message message) {
    //+ UdpMessenger::getChecksum(Message)
      return message.getBuffer().getShort(6);
    //- UdpMessenger::getChecksum(Message)
    }

    public final void setChecksum(Message message, int csum) {
    //+ UdpMessenger::setChecksum(Message, int)
      message.getBuffer().setShort(6, csum);
    //- UdpMessenger::setChecksum(Message, int)
    }

}; //UdpMessenger

